/*
 *	sotel - SSL and OTP telnet for Windows CE
 *  Copyright(C) 1998 NEC Corporation
 *	All rights reserved.
 *	Author: Mizukoshi, Yasuhiro <mizukosi@ccs.mt.nec.co.jp>
 *	E-Mail: pochi@ccs.mt.nec.co.jp
 */

#include	"sotel.h"

int DoSSLTelnet(SOCKET s)
{
	unsigned char buf[128];
	BOOL	bSSL_Listed;

	if (!bCanUseSSL || !bAuth){
		// IAC WONT AUTHENTICATION
		buf[0] = IAC;
		buf[1] = WONT;
		buf[2] = AUTHENTICATION;
		SendTelnet(s, buf, 3);
		return FALSE;
	}
	// Send "IAC WILL AUTHENTICATION" to server.
	buf[0] = IAC;
	buf[1] = WILL;
	buf[2] = AUTHENTICATION;
	SendTelnet(s, buf, 3);
	// IAC SB AUTHENTICATION SEND TYPE_SSL ... NULL IAC SE
	if (RecvTelnet(s, buf, 4) &&
		buf[0] == IAC &&
		buf[1] == SB  &&
		buf[2] == AUTHENTICATION &&
		buf[3] == SEND){
		// AUTHENTICATION type matching
		bSSL_Listed = FALSE;
		do {
			if (!RecvTelnet(s, buf, 1))
				return FALSE;
			if (buf[0] == TYPE_SSL)
				bSSL_Listed = TRUE;
		} while (buf[0] != 0);
		if (!RecvTelnet(s, buf, 2) ||
			buf[0] != IAC ||
			buf[1] != SE){
			return FALSE;
		}
		if (!bSSL_Listed)
			return FALSE;
		// IAC SB AUTHENTICATION IS TYPE_SSL
		// AUTH_WHO_CLIENT|AUTH_HOW_ONE_WAY AUTH_SSL_START IAC SE
		buf[0] = IAC;
		buf[1] = SB;
		buf[2] = AUTHENTICATION;
		buf[3] = IS;
		buf[4] = TYPE_SSL;
		buf[5] = 0;
		buf[6] = AUTH_SSL_START;
		buf[7] = IAC;
		buf[8] = SE;
		SendTelnet(s, buf, 9);
	} else {
		return FALSE;
	}
	// IAC SB AUTHENTICATION REPLY TYPE_SSL
	// AUTH_WHO_CLIENT|AUTH_HOW_ONE_WAY AUTH_SSL_ACCEPT IAC SE
	if (RecvTelnet(s, buf, 9) &&
		buf[0] == IAC &&
		buf[1] == SB &&
		buf[2] == AUTHENTICATION &&
		buf[3] == REPLY &&
		buf[4] == TYPE_SSL &&
		buf[5] == 0 &&
		buf[6] == AUTH_SSL_ACCEPT &&
		buf[7] == IAC &&
		buf[8] == SE){
		// SSL telnet negotiation was completed.
		return TRUE;
	} else {
		return FALSE;
	}
}
