/*
 *	sotel - SSL and OTP telnet for Windows CE
 *  Copyright(C) 1998 NEC Corporation
 *	All rights reserved.
 *	Author: Mizukoshi, Yasuhiro <mizukosi@ccs.mt.nec.co.jp>
 *	E-Mail: pochi@ccs.mt.nec.co.jp
 */

#include	"sotel.h"

unsigned short jis2sjis(unsigned short c)
{
    unsigned char c1, c2;

    c1 = c&0x00ff;
    c2 = (c>>8)&0x00ff;
    if (c1%2){
        c2 += 0x1f;
        if (c2>0x7e){
            c2++;
        }
    } else {
        c2 += 0x7e;
    }
    c1 = 0x81 + (c1-0x21)/2;
    if (c1>0x9f)
        c1 += 0x40;
    return ( (c2<<8) | c1 );
}

unsigned short sjis2jis(unsigned short c)
{
    unsigned char c1, c2;

    c1 = c&0x00ff;
    c2 = (c>>8)&0x00ff;
    if(c1>=0xe0)
        c1 -= 0x40;
    c1 = 0x21 + (c1-0x81)*2;
    if(c2>=0x9f){
        c1++;
        c2 -= 0x7e;
    } else if(c2 > 0x7f){
        c2 -= 0x20;
    } else {
        c2 -= 0x1f;
    }
    return ( (c2<<8) | c1 );
}

unsigned short euc2sjis( unsigned short c )
{
    return jis2sjis( (unsigned short)(c - 0x8080) );
}

unsigned short sjis2euc( unsigned short c )
{
    return sjis2jis( c ) + 0x8080;
}

int j10nc(char *sj, int *kcode, char org)
{
    static unsigned char ctmp[3];
    unsigned char c;

    c = org;
    switch (conv_state){
    case CHARDATA:
        if (c == ESC){
            ctmp[0] = c;
            conv_state = ESCDATA;
        } else if (*kcode != SJIS && (c >= 0xa1 && c <= 0xfe)){
            ctmp[0] = c;
            conv_state = EUC;
        } else if	((c >= 0x81 && c <= 0x9f) || (c >= 0xe0 && c <= 0xfc)){
            ctmp[0] = c;
            conv_state = SJIS;
        } else {
            sj[0] = c;
            return 1;
        }
        return 0;
    case ESCDATA:
        switch (c){
        case '$':
            ctmp[1] = c;
            conv_state = INJIS;
            return 0;
        case '(':
            ctmp[1] = c;
            conv_state = OUTJIS;
            return 0;
        default:
            sj[0] = ctmp[0];
            sj[1] = c;
            conv_state = CHARDATA;
        }
        return 2;
    case INJIS:
        if (c == '@' || c == 'B'){
            ctmp[0] = '\0';
            conv_state = JIS;
            return 0;
        } else {
            sj[0] = ctmp[0];
            sj[1] = ctmp[1];
            sj[2] = c;
            conv_state = CHARDATA;
            return 3;
        }
    case OUTJIS:
        if (c == 'J' || c == 'B'){
            conv_state = CHARDATA;
            return 0;
        } else {
            sj[0] = ctmp[0];
            sj[1] = ctmp[1];
            sj[2] = c;
            conv_state = CHARDATA;
            return 3;
        }
    case JIS:
        if (c == ESC){
            ctmp[0] = c;
            conv_state = ESCDATA;
        } else if (ctmp[0] == '\0'){
            ctmp[0] = c;
        } else {
            ctmp[1] = c;
            *(unsigned short *)sj = jis2sjis(*(unsigned short *)ctmp);
            if (*kcode == 0)
                *kcode = JIS;
            ctmp[0] = '\0';
            return 2;
        }
        return 0;
    case EUC:
        ctmp[1] = c;
        *(unsigned short *)sj = euc2sjis(*(unsigned short *)ctmp);
        if (*kcode == 0)
            *kcode = EUC;
        conv_state = CHARDATA;
        return 2;
    case SJIS:
        sj[0] = ctmp[0];
        sj[1] = c;
        if (*kcode == 0)
            *kcode = SJIS;
        conv_state = CHARDATA;
        return 2;	
    }
}
