/*
 *	sotel - SSL and OTP telnet for Windows CE
 *  Copyright(C) 1998 NEC Corporation
 *	All rights reserved.
 *	Author: Mizukoshi, Yasuhiro <mizukosi@ccs.mt.nec.co.jp>
 *	E-Mail: pochi@ccs.mt.nec.co.jp
 */

#include	"sotel.h"

HANDLE CreateLogFile(LPTSTR tLogFile)
{
	HANDLE hFile;
	hFile = CreateFile(tLogFile, GENERIC_WRITE,
					   FILE_SHARE_WRITE|FILE_SHARE_READ, 0,
					   CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
	if (hFile == INVALID_HANDLE_VALUE)
		hFile = NULL;
	return hFile;
}

void WriteLogFile(HANDLE hFile, char *buf, int len)
{
	int ret, i = 0;
	if (hFile){
		do {
			WriteFile(hFile, buf+i, len, &ret, NULL);
			len -= ret;
			i   += ret;
		} while (len);
	}
}

void CloseLogFile(HANDLE hFile)
{
	if (hFile) CloseHandle(hFile);
}

/* -------------------------------------------------------------------- */

HANDLE hLogFile = NULL;

void CreateLog(LPTSTR tLogFile)
{
	hLogFile = CreateLogFile(tLogFile);
	if (!hLogFile){
		Cputs(TEXT("open error!\n"));
	} else {
		Cputs(TEXT("success\n"));
	}
}

void WriteLog(char *buf, int len)
{
	if (hLogFile) WriteLogFile(hLogFile, buf, len);
}

void CloseLog()
{
	CloseLogFile(hLogFile);
	hLogFile = NULL;
}

/* -------------------------------------------------------------------- */

HANDLE hDbgLogFile = NULL;

void CreateDbgLog()
{
	hDbgLogFile = CreateLogFile(TEXT("soteldbg.txt"));
}

void WriteDbgLog(char *buf, int len)
{
	if (hDbgLogFile) WriteLogFile(hDbgLogFile, buf, len);
}

void CloseDbgLog()
{
	CloseLogFile(hDbgLogFile);
	hDbgLogFile = NULL;
}
