/*
 *	sotel - SSL and OTP telnet for Windows CE
 *  Copyright(C) 1998 NEC Corporation
 *	All rights reserved.
 *	Author: Mizukoshi, Yasuhiro <mizukosi@ccs.mt.nec.co.jp>
 *	E-Mail: pochi@ccs.mt.nec.co.jp
 */

static char CopyRightID[] = "Copyright(C) 1998 NEC Corporation. All rights reserved.";

#include	"sotel.h"

TCHAR	AppName[] = TEXT("sotel");		/* K{ */
TCHAR	Version[] = TEXT("0.1.6");

DWORD   ScreenW  = 80;
DWORD	ScreenH  = 24;
SOCKET	gSock    = INVALID_SOCKET;
int		iSSLmod  = SSL_TELNET;
BOOL	bAuth    = TRUE;
BOOL	bOTP     = TRUE;
BOOL	bSKeyMD5 = FALSE;
BOOL	bDebug   = FALSE;
int		telnet_state, conv_state;
int		iCmdSent, iKcode, iChkAuthByte;
BOOL	bTelnet, bEchoOn, bCanUseSSL;

BOOL LoadRegistory()
{
	HKEY  hKey;
	DWORD dwType;
	DWORD dwLength;
	DWORD dwData;

	if (RegOpenKeyEx(HKEY_CURRENT_USER, SOTEL_SUBKEY, 0, KEY_QUERY_VALUE, &hKey) != ERROR_SUCCESS){
		return FALSE;
	}

	/* bAuth */
	dwType   = REG_DWORD;
	dwLength = sizeof(dwData);
	if (RegQueryValueEx(hKey, AUTH_VALNAME, NULL, &dwType, (LPBYTE)&dwData, &dwLength) == ERROR_SUCCESS)
		bAuth = (BOOL)dwData;

	/* bOTP */
	dwType   = REG_DWORD;
	dwLength = sizeof(dwData);
	if (RegQueryValueEx(hKey, OTP_VALNAME, NULL, &dwType, (LPBYTE)&dwData, &dwLength) == ERROR_SUCCESS)
		bOTP = (BOOL)dwData;

	/* bSKeyMD5 */
	dwType   = REG_DWORD;
	dwLength = sizeof(dwData);
	if (RegQueryValueEx(hKey, SKEYMD5_VALNAME, NULL, &dwType, (LPBYTE)&dwData, &dwLength) == ERROR_SUCCESS)
		bSKeyMD5 = (BOOL)dwData;

	RegCloseKey(hKey);

	return TRUE;
}

BOOL SaveRegistory()
{
	HKEY  hKey;
	DWORD dwType;
	DWORD dwLength;
	DWORD dwData;

	if (RegCreateKeyEx(HKEY_CURRENT_USER, SOTEL_SUBKEY, 0, TEXT(""), REG_OPTION_NON_VOLATILE,
						KEY_WRITE, NULL, &hKey, &dwType) != ERROR_SUCCESS){
		return FALSE;
	}

	/* bAuth */
	dwType   = REG_DWORD;
	dwLength = sizeof(dwData);
	dwData   = (DWORD)bAuth;
	RegSetValueEx(hKey, AUTH_VALNAME, 0, dwType, (LPBYTE)&dwData, dwLength);

	/* bOTP */
	dwType   = REG_DWORD;
	dwLength = sizeof(dwData);
	dwData   = (DWORD)bOTP;
	RegSetValueEx(hKey, OTP_VALNAME, 0, dwType, (LPBYTE)&dwData, dwLength);

	/* bSKeyMD5 */
	dwType   = REG_DWORD;
	dwLength = sizeof(dwData);
	dwData   = (DWORD)bSKeyMD5;
	RegSetValueEx(hKey, SKEYMD5_VALNAME, 0, dwType, (LPBYTE)&dwData, dwLength);

	RegCloseKey(hKey);

	return TRUE;
}

void help(void)
{
	Cputs(AppName);
	Cputs(TEXT(" Ver."));
	Cputs(Version);
	Cputs(TEXT(" - SSL and OTP telnet for WindowsCE\n"));
	Cputs(TEXT("Copyright (C) 1998 NEC Corporation\n"));
	if (!bCanUseSSL)
		Cputs(TEXT("SSL cannot be used on this WindowsCE!\n"));
	Cputs(TEXT("    OPEN    open host [port]\n"));
	Cputs(TEXT("    CLOSE   close\n"));
	Cputs(TEXT("    QUIT    quit\n"));
	Cputs(TEXT("    SSL     ssl {telnet|only}\n"));
	Cputs(TEXT("    AUTH    auth {on|off}\n"));
	Cputs(TEXT("    OTP     otp {on|off|skeymd4|skeymd5}\n"));
	Cputs(TEXT("    LOG     log {open|close} [filename]\n"));
}

int Main(DWORD argc, LPTSTR argv[])
{
	LPTSTR	ptr;
	TCHAR	cmdline[256];
	TCHAR	cmdline2[256];
	WSADATA	wsaData;
	OSVERSIONINFO osver;
	BOOL	bOneHost = FALSE;

	/* OSo[W̎擾 */
	osver.dwOSVersionInfoSize = sizeof(osver);
	GetVersionEx(&osver);
	bCanUseSSL = (osver.dwMajorVersion >= 2) ? TRUE : FALSE;
	/* o[W̕\ */
	wsprintf(cmdline, TEXT("Starting %s Ver.%s\n"), AppName, Version);
	Cputs(cmdline);
	/* ʂ̕E߂ */
	GetWH(&ScreenW, &ScreenH);
	/* WinSock̏ */
	WSAStartup(0x0101, &wsaData);
	/* WXgǂݍ */
	LoadRegistory();

	if (argc > 1){
		bOneHost = TRUE;
		open(argv[1], argc > 2 ? argv[2] : TEXT("23"));
		if (gSock == INVALID_SOCKET)
			goto error;
	}

	while ( 1 ) {
		Cputs(TEXT("telnet>"));
		ptr = Cgets(cmdline);
		if (ptr == NULL){
			Putch(TEXT('\n'));
			continue;
		}
		cmdline2args(cmdline, &Argc, Argv, Quote, cmdline2);
		if (Argc <= 1){
			if (gSock != INVALID_SOCKET){
				Telnet(gSock);
				if (bOneHost && gSock == INVALID_SOCKET)
					break;
			}
			continue;
		}

		// open
		if (!_tcsicmp(Argv[1], TEXT("open"))){
			if (Argc > 2) {
				open(Argv[2], Argc > 3 ? Argv[3] : TEXT("23"));
			} else {
				Cputs(TEXT("open host [port]\n"));
			}
		// close
		} else if (!_tcsicmp(Argv[1], TEXT("close"))){
			close();
			if (bOneHost)
				break;
		// quit
		} else if (!_tcsicmp(Argv[1], TEXT("quit"))){
			close();
			CloseLog();
			CloseDbgLog();
			break;
		// ssl
		} else if (!_tcsicmp(Argv[1], TEXT("ssl"))){
			if (Argc > 2){
				if (!_tcsicmp(Argv[2], TEXT("telnet"))){
					iSSLmod = SSL_TELNET;
					bAuth	= TRUE;
					Cputs(TEXT("SSLtelnet negotiation\n"));
				} else if (!_tcsicmp(Argv[2], TEXT("only"))){
					iSSLmod	= SSL_DIRECT;
					bAuth	= FALSE;
					Cputs(TEXT("SSL only\n"));
				}
			}
		// auth
		} else if (!_tcsicmp(Argv[1], TEXT("auth"))){
			TCHAR tBuf[128];
			if (Argc > 2){
				if (!_tcsicmp(Argv[2], TEXT("on"))){
					bAuth = TRUE;
				} else if (!_tcsicmp(Argv[2], TEXT("off"))){
					bAuth = FALSE;
				}
			}
			SaveRegistory();
			wsprintf(tBuf, TEXT("Authentication : %s\n"),
					 bAuth ? TEXT("ON") : TEXT("OFF"));
			Cputs(tBuf);
		// otp
		} else if (!_tcsicmp(Argv[1], TEXT("otp"))){
			TCHAR tBuf[128];
			if (Argc > 2){
				if (!_tcsicmp(Argv[2], TEXT("on"))){
					bOTP = TRUE;
				} else if (!_tcsicmp(Argv[2], TEXT("off"))){
					bOTP = FALSE;
				} else if (!_tcsicmp(Argv[2], TEXT("skeymd4"))){
					bSKeyMD5 = FALSE;
				} else if (!_tcsicmp(Argv[2], TEXT("skeymd5"))){
					bSKeyMD5 = TRUE;
				}
			}
			SaveRegistory();
			wsprintf(tBuf, TEXT("OTP Check : %s , S/Key MD%s\n"),
					 bOTP ? TEXT("ON") : TEXT("OFF"),
					 bSKeyMD5 ? TEXT("5") : TEXT("4"));
			Cputs(tBuf);
		// log
		} else if (!_tcsicmp(Argv[1], TEXT("log"))){
			if (Argc > 2){
				if (!_tcsicmp(Argv[2], TEXT("open"))){
					CloseLog();
					CreateLog(Argc > 3 ? Argv[3] : TEXT("sotellog.txt"));
				} else if (!_tcsicmp(Argv[2], TEXT("close"))){
					CloseLog();
				}
			}
		// debug
		} else if (!_tcsicmp(Argv[1], TEXT("debug"))){
			bDebug = bDebug ? FALSE : TRUE;
			Cputs(TEXT("Debug Mode : "));
			if (bDebug){
				CreateDbgLog();
				Cputs(TEXT("ON\n"));
			} else {
				CloseDbgLog();
				Cputs(TEXT("OFF\n"));
			}
		// help
		} else {
			help();
		}
	}

error:
	WSACleanup();
	return 0;
}
