/*
 *	sotel - SSL and OTP telnet for Windows CE
 *  Copyright(C) 1998 NEC Corporation
 *	All rights reserved.
 *	Author: Mizukoshi, Yasuhiro <mizukosi@ccs.mt.nec.co.jp>
 *	E-Mail: pochi@ccs.mt.nec.co.jp
 */

#include	"sotel.h"

void open(LPTSTR tHost, LPTSTR tPort)
{
	if (gSock != INVALID_SOCKET){
		Cputs(TEXT("Already connected.\n"));
		goto error;
	}
	/* ^[~i */
	terminit();
	/* ڑ */
	ConnHost(tHost, tPort);
	if (gSock == INVALID_SOCKET)
		goto error;
	/* TELNET */
	Telnet(gSock);

error:
	return;
}

void close()
{
	if (gSock != INVALID_SOCKET){
		Cputs(TEXT("connection closed.\n"));
		closesocket(gSock);
		gSock = INVALID_SOCKET;
	}
}

int CALLBACK fnCertHook(DWORD dwtype, PVOID pvArg, DWORD dwChainLen, LPBLOB pCertChain, DWORD dwFlags)
{
    return SSL_ERR_OKAY;
}

void ConnHost(LPTSTR tHost, LPTSTR tPort)
{
	struct sockaddr_in sa;
	struct hostent *hent;
	int    port = _wtoi(tPort);
	char   host[256];
	BOOL   bOobOpt = TRUE;
	TCHAR  tAddr[64];

	wcstombs(host, tHost, sizeof(host));

	gSock = socket(PF_INET, SOCK_STREAM, 0);
	if (gSock == INVALID_SOCKET){
		Cputs(TEXT("Open error\n"));
		goto error;
	}

	/* SSL̏ */
	if (bCanUseSSL){
		DWORD  optval = SO_SEC_SSL;
		DWORD dwFlags;
		SSLVALIDATECERTHOOK certhook;

		setsockopt(gSock, SOL_SOCKET, SO_SECURE, (char *)&optval, sizeof(optval));
		dwFlags = SSL_FLAG_DEFER_HANDSHAKE;
		WSAIoctl(gSock, SO_SSL_SET_FLAGS, (LPVOID)&dwFlags, sizeof(dwFlags),
				NULL, 0, NULL, NULL, NULL);
		certhook.HookFunc = fnCertHook;
		certhook.pvArg    = NULL;
		WSAIoctl(gSock, SO_SSL_SET_VALIDATE_CERT_HOOK, (LPVOID)&certhook, sizeof(certhook),
				NULL, 0, NULL, NULL, NULL);
	}

	sa.sin_family = AF_INET;
	sa.sin_port	  = htons(port);
	if (!iswdigit(tHost[0])){
		hent = gethostbyname(host);
		if (hent == NULL){
			closesocket(gSock);
			gSock = INVALID_SOCKET;
			Cputs(tHost);
			Cputs(TEXT(": Host name lookup failure\n"));
			goto error;
		}
		sa.sin_addr.s_addr = *(unsigned long *)hent->h_addr_list[0];
	} else {
		sa.sin_addr.s_addr = inet_addr(host);
	}
	memset(sa.sin_zero, 0, 8);
	wsprintf(tAddr, TEXT("Trying %d.%d.%d.%d...\n"),
			 sa.sin_addr.S_un.S_un_b.s_b1,
			 sa.sin_addr.S_un.S_un_b.s_b2,
			 sa.sin_addr.S_un.S_un_b.s_b3,
			 sa.sin_addr.S_un.S_un_b.s_b4);
	Cputs(tAddr);
	/* T[oɐڑ */
	if (SOCKET_ERROR ==
		connect(gSock, (struct sockaddr *)&sa, sizeof(struct sockaddr_in))){
		closesocket(gSock);
		gSock = INVALID_SOCKET;
		Cputs(TEXT("telnet: Unable to connect to remote host"));
		switch(WSAGetLastError()){
		case WSAECONNREFUSED:
			Cputs(TEXT(": Connection refused\n"));
			break;
		case WSAETIMEDOUT:
			Cputs(TEXT(": Connection timed out\n"));
			break;
		case WSAENETUNREACH:
			Cputs(TEXT(": Network is unreachable\n"));
			break;
		default:
		{
			TCHAR tBuf[64];
			wsprintf(tBuf, TEXT(": %d\n"), WSAGetLastError());
			Cputs(tBuf);
		}
			break;
		}
		goto error;
	}
	setsockopt(gSock, SOL_SOCKET, SO_OOBINLINE, (char *)&bOobOpt, sizeof(bOobOpt));

	/* SSLŒʐM */
	if (bCanUseSSL && iSSLmod == SSL_DIRECT){
		WSAIoctl(gSock, SO_SSL_PERFORM_HANDSHAKE, NULL, 0, NULL, 0, NULL, NULL, NULL);
	}

	Cputs(TEXT("Connected to "));
	Cputs(tHost);
	Cputs(TEXT(".\nEscape character is '^]'.\n"));

error:
	return;
}

int RecvTelnet(SOCKET s, char *buf, int len)
{
	int  ret, i = 0;
	do {
		ret = recv(s, buf+i, len, 0);
		if (ret == 0 || ret == SOCKET_ERROR){
			return FALSE;
		}
		len -= ret;
		i   += ret;
	} while (len);
	return TRUE;
}

int SendTelnet(SOCKET s, char *buf, int len)
{
	int ret, i = 0;

	if (bDebug){
		TCHAR tdbuf[8];
		char  dbuf[8];
		int j;
		WriteDbgLog("\nS ", 3);
		for (j = 0; j < len; j++){
			wsprintf(tdbuf, TEXT("%02x"), (unsigned char)buf[j]);
			wcstombs(dbuf, tdbuf, sizeof(dbuf));
			WriteDbgLog(dbuf, strlen(dbuf));
		}
	}

	do {
		ret = send(s, buf+i, len, 0);
		if (ret == 0 || ret == SOCKET_ERROR){
			return FALSE;
		}
		len -= ret;
		i   += ret;
	} while (len);
	return TRUE;
}

void will_termtype(SOCKET s)
{
	unsigned char buf[3];
	if (iCmdSent & WILL_TERMTYPE){
		buf[0]  = IAC;
		buf[1]  = WILL;
		buf[2]  = TERMTYPE;
		SendTelnet(s, buf, 3);
	}
	iCmdSent &= ~WILL_TERMTYPE;
}

void do_sup_ga(SOCKET s)
{
	unsigned char buf[3];
	if (iCmdSent & DO_SUP_GA){
		buf[0] = IAC;
		buf[1] = DO;
		buf[2] = SUP_GA;
		SendTelnet(s, buf, 3);
	}
	iCmdSent &= ~DO_SUP_GA;
}

void will_sup_ga(SOCKET s)
{
	unsigned char buf[3];
	if (iCmdSent & WILL_SUP_GA){
		buf[0] = IAC;
		buf[1] = WILL;
		buf[2] = SUP_GA;
		SendTelnet(s, buf, 3);
	}
	iCmdSent &= ~WILL_SUP_GA;
}

void do_echo(SOCKET s)
{
	unsigned char buf[3];
	if (iCmdSent & DO_ECHO){
		buf[0] = IAC;
		buf[1] = DO;
		buf[2] = ECHO;
		SendTelnet(s, buf, 3);
	}
	iCmdSent &= ~DO_ECHO;
}

void wont_echo(SOCKET s)
{
	unsigned char buf[3];
	if (iCmdSent & WONT_ECHO){
		buf[0] = IAC;
		buf[1] = WONT;
		buf[2] = ECHO;
		bEchoOn= FALSE;
		SendTelnet(s, buf, 3);
	}
	iCmdSent &= ~WONT_ECHO;
}

void will_naws(SOCKET s)
{
	unsigned char buf[3];
	if (iCmdSent & WILL_NAWS){
		buf[0] = IAC;
		buf[1] = WILL;
		buf[2] = NAWS;
		SendTelnet(s, buf, 3);
	}
	iCmdSent &= ~WILL_NAWS;
}

void send_nvtcmd(SOCKET s)
{
	will_termtype(s);	/* ^[~i^Cvݒ */
	do_sup_ga(s);		/* SdʐM */
	will_sup_ga(s);
	do_echo(s);			/* GR[ */
	wont_echo(s);
	will_naws(s);		/* EBhETCYݒ */

	iCmdSent = 0;
}

void dooption(SOCKET s, unsigned char c)
{
	unsigned char buf[16];
	switch(c) {
	case SUP_GA:
		will_sup_ga(s);
		break;
	case TERMTYPE:
		will_termtype(s);
		break;
	case NAWS:
		will_naws(s);
		buf[0] = IAC;
		buf[1] = SB;
		buf[2] = NAWS;
		buf[3] = (unsigned char)(ScreenW / 256);
		buf[4] = (unsigned char)(ScreenW % 256);
		buf[5] = (unsigned char)(ScreenH / 256);
		buf[6] = (unsigned char)(ScreenH % 256);
		buf[7] = IAC;
		buf[8] = SE;
		SendTelnet(s, buf, 9);
		break;
	case AUTHENTICATION:
		if (DoSSLTelnet(s)){
			WSAIoctl(s, SO_SSL_PERFORM_HANDSHAKE, NULL, 0, NULL, 0, NULL, NULL, NULL);
		}
		break;
	case ECHO:
		bEchoOn = FALSE;
	default:
		/* LR}hȊO͎󂯕tȂ */
		buf[0] = IAC;
		buf[1] = WONT;
		buf[2] = c;
		SendTelnet(s, buf, 3);
	}

	return;
}

void sboption(SOCKET s, unsigned char c)
{
	unsigned char buf[16];
	switch(c) {
	case TERMTYPE:
		buf[0] = IAC;
		buf[1] = SB;
		buf[2] = TERMTYPE;
		buf[3] = IS;
		buf[4] = 'v';
		buf[5] = 't';
		buf[6] = '1';
		buf[7] = '0';
		buf[8] = '0';
		buf[9] = IAC;
		buf[10]= SE;
		SendTelnet(s, buf, 11);
		break;
	default:
		break;
	}
	return;
}

void willoption(SOCKET s, unsigned char c)
{
	unsigned char buf[16];
	switch(c) {
	case ECHO:
	case SUP_GA:
		break;
	default:
		/* LR}hȊO͎󂯕tȂ */
		buf[0] = IAC;
		buf[1] = DONT;
		buf[2] = c;
		SendTelnet(s, buf, 3);
		break;
	}
	return;
}

void recv_data(SOCKET s, char *buf, int len)
{
	unsigned char c;

	if (bDebug){
		TCHAR tdbuf[8];
		char  dbuf[8];
		int j;
		WriteDbgLog("\nR ", 3);
		for (j = 0; j < len; j++){
			wsprintf(tdbuf, TEXT("%02x"), (unsigned char)buf[j]);
			wcstombs(dbuf, tdbuf, sizeof(dbuf));
			WriteDbgLog(dbuf, strlen(dbuf));
		}
	}

	while (len){
		c = *buf++;
		len--;

		switch (telnet_state){
		case ST_IAC:
			switch (c){
			case SB:
				telnet_state = ST_SB;
				break;
			case DO:
				telnet_state = ST_DO;
				break;
			case WILL:
				telnet_state = ST_WILL;
				break;
			default:
				if ((0xec <= c && c <= 0xef) ||
					(0xf1 <= c && c <= 0xf9)){
					/* NYI */
					telnet_state = ST_DATA;
				} else {
					telnet_state = ST_CMD;
				}
				break;
			}
			break;
		case ST_DATA:
			if (c == IAC){
				telnet_state = ST_IAC;
				bTelnet = TRUE;
			} else {
				termout(c);
			}
			break;
		case ST_SB:
			sboption(s, TERMTYPE);
			telnet_state = ST_SB2;
			break;
		case ST_SB2:
			if (c == SE){
				telnet_state = ST_DATA;
			}
			break;
		case ST_DO:
			dooption(s, c);
			telnet_state = ST_DATA;
			break;
		case ST_WILL:
			willoption(s, c);
			telnet_state = ST_DATA;
			break;
		case ST_CMD:
			telnet_state = ST_DATA;
			break;
		}
		if (iChkAuthByte < 3)
			iChkAuthByte++;
		if (iCmdSent && bTelnet && iChkAuthByte >= 3){
			send_nvtcmd(s);
		}
	}

	return;
}

void Telnet(SOCKET s)
{
	int   n, len;
	char  Buff[TERMBUFF_SIZE];
	fd_set rfds;
	struct timeval tm;

	while( 1 ){
		FD_ZERO(&rfds);
		FD_SET(s, &rfds);
		tm.tv_sec  = 0;
		tm.tv_usec = 0;
		n = select(1, &rfds, NULL, NULL, &tm);
		if (n == SOCKET_ERROR)
			goto error;
		if (FD_ISSET(s, &rfds)){
			n = recv(s, Buff, TERMBUFF_SIZE, 0);
			if (n == 0 || n == SOCKET_ERROR){
				goto error;
			} else {
				if (bOTP)
					OtpCheck(s, Buff, n);
				recv_data(s, Buff, n);
			}
		}

		len = termin();
		if (len > 0){
			if (SendTelnet(s, TermInBuff, len) == FALSE)
				goto error;
			termin_pos = 0;
		} else if (len < 0){
			Cputs(TEXT("\n"));
			goto escape;
		}

		termpush();
	}

error:
	ResetTerminal();
	close();
	return;

escape:
	ResetTerminal();
	return;
}
