/*
 *	sotel - SSL and OTP telnet for Windows CE
 *  Copyright(C) 1998 NEC Corporation
 *	All rights reserved.
 *	Author: Mizukoshi, Yasuhiro <mizukosi@ccs.mt.nec.co.jp>
 *	E-Mail: pochi@ccs.mt.nec.co.jp
 */

#include	<windows.h>
#include	<stdlib.h>
#include	<winsock.h>
#include	<sslsock.h>
#include	<conslib.h>
#include	<tchar.h>

#define	SOTEL_SUBKEY		TEXT("Software\\NEC\\sotel")
#define	AUTH_VALNAME		TEXT("bAuth")
#define	OTP_VALNAME			TEXT("bOTP")
#define	SKEYMD5_VALNAME		TEXT("bSKeyMD5")

// NVT Control Code
#define	IAC			255
// Option Control Codes
#define	WILL		251
#define	WONT		252
#define	DO			253
#define	DONT		254
#define	SE			240
#define	SB			250
// TELNET Option Codes
#define	ECHO		 1
#define	SUP_GA		 3
#define	TERMTYPE	24
#define	NAWS		31
// Authentication Commands
#define	AUTHENTICATION		37
#define		IS					0
#define		SEND				1
#define		REPLY				2
#define		NAME				3
// Authentication Types
#define	TYPE_KERBEROS_V4		1
#define	TYPE_KERBEROS_V5		2
#define	TYPE_SPX				3
#define	TYPE_RSA				6
#define	TYPE_SSL				7
#define	TYPE_LOKI				10
// Modifiers
#define	AUTH_WHO_MASK			1
#define	AUTH_CLIENT_TO_SERVER	0
#define	AUTH_SERVER_TO_CLIENT	1
#define	AUTH_HOW_MASK			2
#define	AUTH_HOW_ONE_WAY		0
#define	AUTH_HOW_MUTIAL			2
// SSL Type
#define	AUTH_SSL_START			1
#define	AUTH_SSL_ACCEPT			2
#define	AUTH_SSL_REJECT			3

// TELNETvgȐ
#define ST_DATA		0
#define ST_IAC		1
#define ST_SB		2
#define	ST_SB2		3
#define ST_CMD		4
#define ST_DO		5
#define	ST_WILL		6

// TELNETR}hM
#define	WILL_TERMTYPE	0x0001
#define	DO_SUP_GA		0x0002
#define	WILL_SUP_GA		0x0004
#define	DO_ECHO			0x0008
#define	WONT_ECHO		0x0010
#define	WILL_NAWS		0x0020

// SSLlSVG[V[h
#define	SSL_TELNET	0
#define	SSL_DIRECT	1

// VT100G~[V
#define	BEL			0x07
#define	BS			0x08
#define	TAB			0x09
#define	LF			0x0a
#define	CR			0x0d
#define	SO			0x0e
#define	SI			0x0f
#define	ESC			0x1b
#define	DEL			0x7f

// ^[~ĩobt@TCY
#define	TERMBUFF_SIZE	2048
#define	KEYBUFF_SIZE	16

// R[hϊ̏
#define JIS         1
#define CHARDATA    2
#define ESCDATA     3
#define EUC         4
#define SJIS        5
#define INJIS       6
#define OUTJIS      7

// OTP
#define	MAX_OTPBUF_SIZE			256
#define	PASS_PHRASE_MIN_LEN		8
#define	PASS_PHRASE_MAX_LEN		256
#define	SEED_MAX_LEN			1024
#define	ONETIME_KEY_MAX_LEN		256
#define	CRLF					"\r\n"
#define	FUNCNAME_MD2			TEXT("md2")
#define	FUNCNAME_MD4			TEXT("md4")
#define	FUNCNAME_MD5			TEXT("md5")
#define	FUNCNAME_SHA1			TEXT("sha1")
#define	MD2						0
#define	MD4						1
#define	MD5						2
#define	SHA1					3

extern DWORD	ScreenW;
extern DWORD	ScreenH;
extern SOCKET	gSock;
extern int		telnet_state;
extern int		conv_state;
extern int		iSSLmod;
extern BOOL		bAuth;
extern BOOL		bOTP;
extern BOOL		bSKeyMD5;
extern BOOL		bTelnet;
extern BOOL		iCmdSent;
extern BOOL		bEchoOn;
extern BOOL		bCanUseSSL;
extern int		iKcode;
extern int		iChkAuthByte;
extern BOOL		bDebug;
extern char		TermInBuff[TERMBUFF_SIZE + 1];
extern int		termin_pos;

extern int   hash_func;
extern int   seq;
extern char  seed[SEED_MAX_LEN];
extern char  pass[ONETIME_KEY_MAX_LEN];
extern int   (* KeyCrunchFunc)(char *, char *, char *);
extern void  (* IterateFunc)  (char *);
extern TCHAR FuncName[16];
extern char  *OTP_btoe(char *, char *);
extern int   _otp_MD4_keycrunch(char *, char *, char *);
extern void  _otp_MD4_iterate(char *);
extern int   _otp_MD5_keycrunch(char *, char *, char *);
extern void  _otp_MD5_iterate(char *);
extern int   _otp_SHA1_keycrunch(char *result, char *seed, char *passwd);
extern void  _otp_SHA1_iterate(char *x);

void   open(LPTSTR tHost, LPTSTR tPort);
void   close();
void   ConnHost(LPTSTR tHost, LPTSTR tPort);
void   Telnet(SOCKET s);
void   terminit();
int    termin();
void   termout(unsigned char c);
void   termpush();
int    j10nc(char *sj, int *kcode, char org);
int    RecvTelnet(SOCKET s, char *buf, int len);
int    SendTelnet(SOCKET s, char *buf, int len);
int    DoSSLTelnet(SOCKET s);
void   OtpCheck(SOCKET s, char *buf, int len);
BOOL   CALLBACK PassphraseDlgProc(HWND hWnd, UINT uMessage,
					WPARAM wParam, LPARAM lParam);
void   CreateLog(LPTSTR tLogFile);
void   WriteLog(char *buf, int len);
void   CloseLog();
void   CreateDbgLog();
void   WriteDbgLog(char *buf, int len);
void   CloseDbgLog();
